/*
 * GTI (Generic Tools Infrastructure)
 * Copyright (C) ZIH, Technische Universitaet Dresden, Federal Republic of Germany, 2011-2015
 * Copyright (C) Lawrence Livermore National Laboratories, United States of America, 2011-2015
 * Copyright (C) RWTH Aachen University, Federal Republic of Germany, 2013-2015
 *
 * See the file LICENSE.txt in the package base directory for details
 */

/**
 * @file I_PanicFilter.h
 *       @see I_PanicFilter.
 *
 *  @date 11.07.2012
 *  @author Tobias Hilbrich, Joachim Protze, Mathias Korepkat
 */

#include "I_Module.h"
#include "GtiEnums.h"
#include "I_Reduction.h"
#include "I_ChannelId.h"

#include <list>

#ifndef I_PANICFILTER_H
#define I_PANICFILTER_H

/**
 * Removes unnecessary gtiRaisePanic events.
 *
 * Dependencies (order as listed):
 * - X
 *
 */
class I_PanicFilter : public gti::I_Module, public gti::I_Reduction
{
public:

    /**
     * Called when a panic event arrives.
     *
     * @return see gti::GTI_ANALYSIS_RETURN.
     */
    virtual gti::GTI_ANALYSIS_RETURN propagate (
            gti::I_ChannelId *thisChannel,
            std::list<gti::I_ChannelId*> *outFinishedChannels) = 0;
};/*class I_PanicFilter*/

#endif /*I_PANICFILTER_H*/
