/*
 * GTI (Generic Tools Infrastructure)
 * Copyright (C) ZIH, Technische Universitaet Dresden, Federal Republic of Germany, 2011-2015
 * Copyright (C) Lawrence Livermore National Laboratories, United States of America, 2011-2015
 * Copyright (C) RWTH Aachen University, Federal Republic of Germany, 2013-2015
 *
 * See the file LICENSE.txt in the package base directory for details
 */

/**
 * @file I_PanicHandler.h
 *       @see I_PanicHandler.
 *
 *  @date 11.07.2012
 *  @author Tobias Hilbrich, Joachim Protze, Mathias Korepkat
 */

#include "I_Module.h"
#include "GtiEnums.h"

#ifndef I_PANICHANDLER_H
#define I_PANICHANDLER_H

/**
 * Handler for GTI panic signals.
 * If a panic event arives (the first one), it notifies all non-application TBON nodes
 * of the ongoing panic, i.e., pending application crash.
 *
 * Dependencies (order as listed):
 * - X
 */
class I_PanicHandler : public gti::I_Module
{
public:

    /**
     * Notification of a panic event.
     *
     * @return see gti::GTI_ANALYSIS_RETURN.
     */
    virtual gti::GTI_ANALYSIS_RETURN raisePanic (void) = 0;

};/*class I_PanicHandler*/

#endif /*I_PANICHANDLER_H*/
