/*
 * GTI (Generic Tools Infrastructure)
 * Copyright (C) ZIH, Technische Universitaet Dresden, Federal Republic of Germany, 2011-2015
 * Copyright (C) Lawrence Livermore National Laboratories, United States of America, 2011-2015
 * Copyright (C) RWTH Aachen University, Federal Republic of Germany, 2013-2015
 *
 * See the file LICENSE.txt in the package base directory for details
 */

/**
 * @file I_ShutdownReceiver.h
 *       @see I_ShutdownReceiver.
 *
 *  @date 27.06.2012
 *  @author Tobias Hilbrich, Joachim Protze, Mathias Korepkat
 */

#include "I_Module.h"
#include "GtiEnums.h"

#ifndef I_SHUTDOWNRECEIVER_H
#define I_SHUTDOWNRECEIVER_H

/**
 * Module that listens for the shutdown event created by ShutdownHandler.
 * It performs no action with this event, it just makes sure that it is forwarded
 * to the right places.
 *
 * Dependencies (order as listed):
 * - X
 *
 */
class I_ShutdownReceiver : public gti::I_Module
{
public:

    /**
     * Called when the shutdown event arrives.
     *
     * @return see gti::GTI_ANALYSIS_RETURN.
     */
    virtual gti::GTI_ANALYSIS_RETURN receive (void) = 0;
};/*class I_ShutdownReceiver*/

#endif /*I_SHUTDOWNRECEIVER_H*/
